'use client'
import { useMutation } from '@tanstack/react-query'
import { UpdateBuildSitesUpdate } from './types';
import { toISOIfNotZ } from '@/lib/utils';

const fetchGraphQlBuildAddressUpdate = async (record: UpdateBuildSitesUpdate, uuid: string): Promise<{ data: UpdateBuildSitesUpdate | null; status: number }> => {
    console.log('Fetching test data from local API');
    record.expiryStarts = record.expiryStarts ? toISOIfNotZ(record.expiryStarts) : undefined;
    record.expiryEnds = record.expiryEnds ? toISOIfNotZ(record.expiryEnds) : undefined;
    try {
        const res = await fetch(`/api/build-sites/update?uuid=${uuid || ''}`, { method: 'POST', cache: 'no-store', credentials: "include", body: JSON.stringify({ ...record }) });
        if (!res.ok) { const errorText = await res.text(); console.error('Test data API error:', errorText); throw new Error(`API error: ${res.status} ${res.statusText}`) }
        const data = await res.json();
        return { data: data.data, status: res.status }
    } catch (error) { console.error('Error fetching test data:', error); throw error }
};

export function useUpdateBuildSitesMutation() {
    return useMutation({
        mutationFn: ({ data, uuid }: { data: UpdateBuildSitesUpdate, uuid: string }) => fetchGraphQlBuildAddressUpdate(data, uuid),
        onSuccess: () => { console.log("Build Sites updated successfully") },
        onError: (error) => { console.error("Update Build Sites failed:", error) },
    })
}
